#! /usr/bin/env tclsh
#
# This script builds a tcl script to tell the wrap version of filerunner
# about the included packages.  The un-wrapped version does not need this,
# but the lack of glob to find files in the wrapped filerunner, requires
# this.
# 
# The file this builds is intended to be sourced, so make every thing global.
#
# Input should be the file name of the file containing the list of files to
# be wrapped.  We assume that that name also supplies the directory where
# we will put the resulting script and also the directory where the packages
# are to be found.
#
proc echo {mess} {
  if {$::v} {
    puts "$mess"
  }
}
set v    [lindex $argv 1]
if {$v != "1"} {
  set v 0
}
set file [lindex $argv 0]
if {![file exists $file]} {
  puts "Could not find file $file.  Out of here!"
  exit 1
}

set ffile [file join [pwd] $file]
set dir [file dirname $ffile]
set diro [file dirname $dir]

echo "full file name: $ffile \nDirname $dir "

set fid [open $ffile r]
set fido [open $diro/packageLinks.tcl w]

puts $fido "# This file is automaticly generated by the 'wrap' process.\
           \n# The actual generating file is 'makepackagelinks.tcl'.\
           \n# It is only used by the wrapped filerunner to over come\
           \n# the 'glob' short comming of the wrap code.\
           \n\n# It is intended that this file will be sourced by filerunner\
           \n# after it has found its library.\
           \n\n"

foreach line [split [read $fid] \n] {
  echo "Checking $line"
  if {[string match {packages/*} $line] && \
	  ![string match {packages/*/*} $line]} {
    echo "Found $line"
    puts $fido \
	"set ::auto_path \[linsert \$::auto_path 0 \$::glob(lib_fr)/$line]"
  }
}
close $fido
close $fid
exit 0
