
# These should use the "quick" option, I think...
proc CmdToright {} {
  global glob
  NewPwd right $glob(left,pwd)
  UpdateWindow_ right 1
}

proc CmdToleft {} {
  global glob
  NewPwd left $glob(right,pwd)
  UpdateWindow_ left 1
}

proc CmdSwapWindows {} {
  global glob
  set tmpright $glob(left,pwd)
  set glob(forceupdate) 1
  CmdToleft
  NewPwd right $tmpright
  UpdateWindow right
  set glob(forceupdate) 0
}

proc BatchReceiveFTP { inst } {
  global glob
  if {[IsFTP $glob($inst,pwd)]} {
    PopInfo [_ "You can only issue a receive request to a non-FTP directory"]
    return
  }
  set olddir $glob([Opposite $inst],pwd)
  foreach itemblock $glob(batchlist) {
    set item [lindex $itemblock 0]
    set r [regexp {ftp://([^/]*)(.*)} $item match ftpI elem]
    if {!$r} {
      PopWarn [_ "Can't parse %s as FTP file" $item]
    } else {
      NewPwd [Opposite $inst] ftp://$ftpI/
      set r [Try { FTP_GetFile $ftpI "$elem" \
		       "$glob($inst,pwd)/[file tail $elem]" \
		       [lindex $itemblock 1] 0 } "" 1]
    }
  }
  set glob(batchlist) {}
  set glob(forceupdate) 1
  NewPwd [Opposite $inst] $olddir
  UpdateWindow both
  set glob(forceupdate) 0
}

proc SandDsame {} {
    smart_dialog .apop . [_ "Oops That doesn't work"] \
	[list [_ "Please set different source and destination directories!"]]\
	0 1 [_ "OK"] 
}

proc CmdCopy {{resume 0}} {
  global glob
  if { $glob(left,pwd) == $glob(right,pwd) } {
    SandDsame
    return {}
  }    
  CmdCopy_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) left $resume ""
  CmdCopy_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right $resume ""
  UpdateWindow both
  set glob(forceupdate) 0
}
proc CmdHardlnk {{resume 0}} {
  global glob
  global config
  if { $config(cmd,hardlink) == "" } {
    smart_dialog .apop . [_ "Sorry"] \
	[list [_ "The hard link command is not configured\
                   (see Configuration menu)."]]\
	 0 1 [_ "OK"]
    return {}
  }
  if { $glob(left,pwd) == $glob(right,pwd) } {
    SandDsame 
    return {}
  }
  if { [lindex $config(cmd,hardlink) 1] == "r" } {
    set r left
    set l right
    set cmd [lindex $config(cmd,hardlink) 0]
  } else {
    set r right
    set l left
    set cmd $config(cmd,hardlink)
  }
  CmdCopy_ $glob(listbox,left).file glob(left,filelist) \
      $glob($l,pwd) $glob($r,pwd) left $resume $cmd
  CmdCopy_ $glob(listbox,right).file glob(right,filelist) \
      $glob($r,pwd) $glob($l,pwd) right $resume $cmd
  UpdateWindow both
  set glob(forceupdate) 0
}

proc CmdCopy_ { listb_name filelist_var frompwd topwd inst resume option} {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist
  set cpcmd $option
  if { $cpcmd == "" } {
    set cpcmd $config(cmd,cp)
  }
# Copy and copyas copy links, not what they point at
  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Copy"]]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    set ffile $frompwd/[lindex $elem 1]
    Log [_ "%s switching on %s" CmdCopy_ [lindex $elem 2]]
    switch $swt {
      fld -
      fd  { 
        if {[IsFTP $topwd]} {
	  Log [_ "IsFTP source and destination(1)"]
          CantDoThat
          return
        }
        set olddir $glob($inst,pwd)
        set r [Try {CopyFromFTPRecursive "$ffile" "$topwd" $inst $resume } "" 1]
        NewPwd $inst $olddir
        UpdateWindow $inst
    }
      fl  -
      fn  {
	if { $option != "" } {
	  Log [_ "IsFTP source and options %s" $option]
          CantDoThat
          return
        }	      
        if {[IsFTP $topwd]} {
	  Log [_ "IsFTP source and destination(2)"]
          CantDoThat
          return
        }
        set r [regexp {ftp://([^/]*)(.*)} $frompwd match ftpI directory]
        if {$r == 0} { 
          PopError [_ "Can't parse %s as ftp URL" $frompwd] 
        } else {
          set size [lindex $elem 3]
          if {[lindex $elem 2] == "fl"} {set size -1}
          if {$glob(async)} {
            catch {exec $glob(lib_fr)/frftp $glob(lib_fr) \
		       $config(ftp,timeout) 1 $glob(ftp,$ftpI,host) \
                       $glob(ftp,$ftpI,user) $glob(ftp,$ftpI,passwd) \
		       $ftpI "$directory/[lindex $elem 1]" \
                       "$topwd/[lindex $elem 1]" $size $resume &} out
          } else {
            set r [Try { FTP_GetFile $ftpI \
			     "$directory/[lindex $elem 1]" \
			     "$topwd/[lindex $elem 1]" \
			     $size $resume } "" 1]
          }
        }
    }
      n -
      wl -
      l   { 
        Log [_ "Copying (1) %s >> %s"  "$cpcmd $ffile" "$topwd"]
        set r [regexp {ftp://([^/]*)(.*)} $topwd match ftpI directory]
        if {$r} {
	  if { $option != "" } {
	        Log [_ "ftp: and options %s" $option]
		CantDoThat
		return
	    }	      
          set glob(forceupdate) 1
          Try { FTP_PutFile $ftpI $ffile \
		    $directory/[lindex $elem 1] [lindex $elem 3] } "" 1
        } else {
          if {[CheckWhoOwns $topwd/[lindex $elem 1] overwrite]} {
	    # Use "" on the try script & not {} so the command is expaned and not
	    # taken as one parameter (hard to find 'cp -f')
	    if {$cpcmd != ""} {
	      Try  "exec  $cpcmd [list \
                [FixFileName $ffile 1 "" 1] \
		       [FixFileName $topwd 1 "" 1]]" "" 1 $glob(async)
	    } else {
	      Try [list file copy -force  \
		       [FixFileName $ffile 1 "" 1] \
		       [FixFileName $topwd 1 "" 1]] "" 1 
	    }
          }
        }
      }

      d   -
      wld -
      ld   { 
       if {[IsFTP $topwd]} {
	  if { $option != "" } {
	        Log [_ "IsFTP and options %s" $option]
		CantDoThat
		return
	    }	      
          set olddir $glob($inst,pwd)
          set r [Try { CopyToFTPRecursive $ffile $topwd $inst } "" 1]
          NewPwd $inst $olddir
          set glob(forceupdate) 1
	  UpdateWindow $inst
	  set glob(forceupdate) 0
        } else {
	  if {[CheckWhoOwns $topwd/[lindex $elem 1] overwrite]} {
	    if { $option == "" } {
	      set cpcmd $config(cmd,dircp)
	    }
	    Log [_ "Copying(d) %s >> %s" "$cpcmd  $ffile" $topwd]
	    if { $cpcmd == "" } {
	      Try [list file copy \
		       [FixFileName $ffile 1 "" 1 ] \
		       [FixFileName $topwd 1 "" 1 ]] "" 1 
	    } else {
	      # we don't put $cpcmd in the list as it would make a possible
	      # space delimited thing into one parm i.e. 'cp -pfr' would be
	      # treated as a program name rather than a name and option
	      Try  "exec $cpcmd [list\
                [FixFileName $ffile 1 "" 1 ] \
		       [FixFileName $topwd 1 "" 1 ]]"\
		  "" 1 $glob(async)
	    }
          }
        }
    }
      default {
	  Log [_  "file type %s ??" [lindex $elem 2]]
	  CantDoThat
      }
    }
  }
}

proc CmdCopyAs {} {
  global glob
  CmdCopyAs_ $glob(listbox,left).file glob(left,filelist) $glob(left,pwd) $glob(right,pwd)
  CmdCopyAs_ $glob(listbox,right).file glob(right,filelist) $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
}

proc CmdCopyAs_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_  "CopyAs"]]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    set ffile $frompwd/[lindex $elem 1]
    switch $swt {
      fl -
      fn -
      l  -
      n  {set query [_ "destination file"]
      }
      d  -
      wld -
      ld {set query [_ "directory after copy"]
      }
      default {
	CantDoThat
	return
      }
    }
    set destfile [EntryDialog "" [_  "Copy As..."] \
		      [_  "Please enter new name for %s" $query] \
		      $topwd/[lindex $elem 1] question [buildDialogConfig]]
    if {$destfile == "" } {return}

    if {[IsFTP $destfile]} {
      CantDoThat
      return
    }
    switch $swt {
      fl  -
      fn  {
	#         set r [regexp {ftp://([^/]*)(.*)} $frompwd match ftpI directory]
	if {![IsFTP $frompwd]} { 
	  PopError [_ "Can't parse %s as ftp URL" $frompwd] 
	} else {
	  set size [lindex $elem 3]
	  if {[lindex $elem 2] == "fl"} {set size -1}
	  if {$glob(async)} {
	    catch {exec $glob(lib_fr)/frftp $glob(lib_fr)\
		       $config(ftp,timeout) 1 $glob(ftp,$ftpI,host) \
		       $glob(ftp,$ftpI,user) $glob(ftp,$ftpI,passwd)\
		       $ftpI "$directory/[lindex $elem 1]" \
		       "$destfile" $size 0 &} out
	  } else {
	    set r [Try { FTP_GetFile $ftpI \
			     "$directory/[lindex $elem 1]"\
			     "$destfile" $size 0 } "" 1]
	  }
	}
      }
      n  -
      wl -
      l   { 
	Log [_ "Copying %s >> %s" \
		 "$config(cmd,cp) $frompwd/[lindex $elem 1]" $destfile]
	if { $config(cmd,cp) == "" } {
	  Try [list file copy \
		   [FixFileName $ffile 1 "" 1] \
		   [FixFileName $destfile 1 "" 1]] "" 1  $glob(async)
	} else {
	  Try "exec $config(cmd,cp) [list \
                [FixFileName $ffile 1 "" 1] \
                [FixFileName $destfile 1 "" 1]]" "" 1  $glob(async)
	}
      }
      d   -
      wld -
      ld  { 
	Log [_  "Copying %s to %s" \
		 "$config(cmd,cp) $frompwd/[lindex $elem 1]" $destfile]
	if { $config(cmd,dircp) == "" } {
	  Try [list file copy \
		   [FixFileName $ffile 1 "" 1]\
		   [FixFileName $destfile 1 "" 1]] "" 1  $glob(async)
	} else {
	  Try "exec $config(cmd,dircp) [list \
              [FixFileName $ffile 1 "" 1]\
              [FixFileName $destfile 1 "" 1]]" "" 1  $glob(async)
	}
      }
      default CantDoThat
    }
  }
}

proc SoftLink { src dst } {
  global config
  if {$config(create_relative_links)} {
    set srcdir [file dirname $src]
    set dstdir [file dirname $dst]
    set srcfile [file tail $src]
    set dstfile [file tail $dst]
    set dstlist [split $dstdir /]
    set srclist [split $srcdir /]
    set dstlen [llength $dstlist]
    set srclen [llength $srclist]
    # Count how many directories are the same in the source and destination paths
    set index 0
    while {([lindex $srclist $index] == [lindex $dstlist $index]) && \
	       ($index < $srclen) && ($index < $dstlen)} {
      incr index
    }
    # Build relative link
    set link {}
    for {set dstindex $index} {$dstindex < $dstlen} {incr dstindex} {
      append link ../
    }
    for {set srcindex $index} {$srcindex < $srclen} {incr srcindex} {
      append link [lindex $srclist $srcindex]/
    }
    set from $link$srcfile
    cd $dstdir
    Log [_ "%s : file -s %s" \
	     "$src $dst $srcdir $srcfile $dstdir $dstfile" "$dst $from"]
    if {[Try {file link -symbolic $dst $from} "" 0] == 1 } {
       Try {file link  $dst $from} "" 1
    }
   
  } else {
    Try {file link -symbolic $dst $src} "" 1
  }
}

proc CmdSoftLink {} {
  global glob
  if { $glob(left,pwd) == $glob(right,pwd) } {
    SandDsame
    return {}
  }    
  if {[IsFTP $glob(left,pwd)] || [IsFTP $glob(right,pwd)]} {
    # Well, with FTP we actually can, but we need them both to be
    # on the same remote 
    set l [regexp {([a-z]?)ftp://([^/]*)(.*)} $glob(left,pwd) \
	       match lsftp lftpI ldirectory]
    set r [regexp {([a-z]?)ftp://([^/]*)(.*)} $glob(right,pwd) \
	       match rsftp rftpI rdirectory]
    if {$l && $r && $rftpI == $lftpI} {

    } else {
      frputs "softlink " l r rftpI lftpI  glob(left,pwd) glob(right,pwd)
      CantDoThat
      return
    }
  }
  CmdSoftLink_ $glob(listbox,left).file glob(left,filelist) $glob(left,pwd) $glob(right,pwd)
  CmdSoftLink_ $glob(listbox,right).file glob(right,filelist) $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
}

proc CmdSoftLink_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "SoftLink"]]} return
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      n   -
      d   -
      l   -
      wl  -
      wld -
      ld  { 
        Log [_ "Softlinking %s to %s" "$frompwd/[lindex $elem 1]" $topwd]
        SoftLink $frompwd/[lindex $elem 1] $topwd/[lindex $elem 1]
      }
      fn -
      fd -
      fl -
      fld {
       Log [_ "Softlinking %s to %s" "$frompwd/[lindex $elem 1]" $topwd]
	regexp {ftp://([^/]*)(.*)} $frompwd match ftpI directory
	regexp {ftp://([^/]*)(.*)} $topwd match ftpI tdirectory
	Try {FTP_LinkFile $ftpI \
		 "$directory/[lindex $elem 1]" \
		 "$tdirectory/[lindex $elem 1]"} "" 1
	set glob(forceupdate) 1
      }
      default {
	CantDoThat
	return
      }
    }
  }
}

proc CmdSoftLinkAs {} {
  global glob
  CmdSoftLinkAs_ $glob(listbox,left).file glob(left,filelist) $glob(left,pwd) $glob(right,pwd)
  CmdSoftLinkAs_ $glob(listbox,right).file glob(right,filelist) $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
}

proc CmdSoftLinkAs_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "SoftLinkAs"]]} return
    set elem [lindex $filelist $sel]
    set destfile [EntryDialog  "" [_ "Soft-Link As..."] \
		      [_ "Please enter new name for destination link"] \
		      $topwd/[lindex $elem 1] question [buildDialogConfig]]
    if {[IsFTP $frompwd] || [IsFTP $destfile]} {
      # Well, with SFTP we actually can, but we need them both to be
      # on the same remote & SFTP (but I said that)
      set l [regexp {([a-z]?)ftp://([^/]*)(.*)} $frompwd \
		 match lsftp lftpI ldirectory]
      set r [regexp {([a-z]?)ftp://([^/]*)(.*)} $destfile \
		 match rsftp rftpI rdirectory]
 #     puts "$l && $r && $rftpI == $lftpI && $lsftp $ldirectory $rdirectory"
      if {$l && $r && ($rftpI == $lftpI) } {
      } else {
	CantDoThat
	return
      }
    }
    if {$destfile != "" } {
      Log [_ "Softlinking %s to %s" "$frompwd/[lindex $elem 1]" $destfile]
      switch [lindex $elem 2] {
	n   -
	d   -
	l   -
	wl  -
	wld -
	ld  {
          SoftLink $frompwd/[lindex $elem 1] $destfile
        }
	fn -
	fd -
	fl -
	fld {
	  Log [_ "Softlinking %s to %s" "$frompwd/[lindex $elem 1]" $destfile]
	  Try {FTP_LinkFile $rftpI \
		   "$ldirectory/[lindex $elem 1]" \
		   "$rdirectory"} "" 1
	  set glob(forceupdate) 1
	}
	default {CantDoThat}
      }
    }
  }
}


proc CmdMove {} {
  global glob
  if { $glob(left,pwd) == $glob(right,pwd) } {
    SandDsame
    return {}
  }    
#  if {[IsFTP $glob(left,pwd)] || [IsFTP $glob(right,pwd)]} {
#    FTP_Move
#    return
#  }
  CmdMove_ $glob(listbox,left).file glob(left,filelist) $glob(left,pwd) $glob(right,pwd)
  CmdMove_ $glob(listbox,right).file glob(right,filelist) $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
}

proc CmdMove_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Move"]]} return
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      d   -
      l   -
      wl  -
      ld  -
      wld -
      n   { 
        if {[CheckWhoOwns $frompwd/[lindex $elem 1] move] && \
		[CheckWhoOwns $topwd/[lindex $elem 1] overwrite]} {
          Log [_ "Moving %s to %s" $frompwd/[lindex $elem 1] $topwd]
          Try { file rename -force -- \
		    $frompwd/[lindex $elem 1] $topwd } "" 1 $glob(async)
        }
      }
      fn  -
      fld -
      fl  -
      fd {
	set rf [regexp {ftp://([^/]*)(.*)} \
		    $frompwd/[lindex $elem 1] match ftpIf ffile]
	set rt [regexp {ftp://([^/]*)(.*)} \
		    $topwd/[lindex $elem 1] match ftpIt tfile]
	if {$rf == 1 && $rt == 1 && $ftpIf == $ftpIt } {
	  Try { FTP_Rename $ftpIf $ffile $tfile } "" 1
	  set glob(forceupdate) 1	  
	} else {
	  # to or from either different ftp locations or ftp & local file
	  # do a copy followed by a delete
	  # maybe later...
          CantDoThat
          return
	}  
      }
	
      default CantDoThat
    }
  }
}

proc CmdDelete {} {
  global glob
  CmdDelete_ $glob(listbox,left).file glob(left,filelist) $glob(left,pwd) $glob(right,pwd) left
  CmdDelete_ $glob(listbox,right).file glob(right,filelist) $glob(right,pwd) $glob(left,pwd) right
  UpdateWindow both
  set glob(forceupdate) 0
}

proc deleteQuery {ford frompwd elem} {
  if {$ford == ""} {return 0}
  return [smart_dialog .apop . [_ "Sure?"] \
	      [list [_ "OK to delete %s ?" \
			 "$ford $frompwd/[lindex $elem 1]"]]\
	      0 2 [list [_ "Yes"] [_ "No"]]]
}

proc CmdDelete_ { listb_name filelist_var frompwd topwd inst } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Delete"]]} return
    set elem [lindex $filelist $sel]
    set type [lindex $elem 2]
    set ford [switch $type {
      d -     
      fd {if {$config(ask,dir_delete)} {expr {{directory tree}}}} 
      default {if {$config(ask,file_delete)} {expr {{file}}}}
    }]
    switch $type {
      l   -
      wl  -
      ld  -
      wld -
      n   -
      d { 
        set ask [deleteQuery $ford $frompwd $elem]
	if {$ask == 0} {
          if {[CheckWhoOwns $frompwd/[lindex $elem 1] delete]} {
            Log [_ "Deleting %s" $frompwd/[lindex $elem 1]]
            Try { file delete -force -- $frompwd/[lindex $elem 1] } "" 1
          }
        }
      }
      fn  -
      fld -
      fl  {
	set ask [deleteQuery $ford $frompwd $elem]
        if {$ask == 0} {
          Log [_ "Deleting %s" $frompwd/[lindex $elem 1]]
          set r [regexp {ftp://([^/]*)(.*)} \
		     $frompwd/[lindex $elem 1] match ftpI file]
          if {$r} {
            set glob(forceupdate) 1
            Try { FTP_Delete $ftpI "$file" } "" 1
          }
        }
      }
      fd  {
	set ask [deleteQuery $ford $frompwd $elem]
	if {$ask == 0} {
	  Log [_ "Deleting %s" $frompwd/[lindex $elem 1]]
	  set glob(forceupdate) 1
	  Try { DeleteFTPRecursive "$frompwd/[lindex $elem 1]" $inst } "" 1
        }
      }
      default CantDoThat
    }
  }
}
# This command is nearly the same as View  It uses the windows
# file 'assoc' and 'ftype' functions to figure out how
# to 'open' a file.  (We use 'open' as windows means it.)


proc CmdOpen {} {
#  puts "CmdWinOpen"
  global glob
  CmdView_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) left open
  CmdView_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right open
}


proc CmdView {} {
#  puts "CmdView"
  global glob
  CmdView_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) left
  CmdView_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right
}

proc CmdView_ { listb_name filelist_var frompwd topwd inst {extList view}} {
  # For speed, (hopefully) we'll call by reference...
#  puts "CmdView_"
  global glob config env
  upvar $filelist_var filelist
  set filenamelist {}
  set filenameorg {}
  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "View"]]} return
    set fileelem [lindex $filelist $sel]
    set file1 $frompwd/[lindex $fileelem 1]
    # for windows lnk files we pass both the translated version and the file
    switch [lindex $fileelem 2] {
      l   -
      n   { 
	lappend filenamelist $file1
	lappend filenameorg  $file1
      }
      wl  { 
	lappend filenamelist [TranslateLnk [wLinkName $inst $fileelem] \
				      [lindex $glob($inst,df) 1]]
	lappend filenameorg $file1
      }
      wld {
	set newdir [TranslateLnk [wLinkName $inst $fileelem] \
			[lindex $glob($inst,df) 1]]
	if {$newdir != {}} {
	  NewPwd $inst $newdir
	  UpdateWindow $inst
	}
      }
      fd  -
      fld -
      ld  - 
      d   { NewPwd $inst $glob($inst,pwd)/[lindex $fileelem 1]
	         UpdateWindow $inst
	         return
          }
      fn  -
      fl  { 
	set file [MoveToTmp $fileelem $inst]
	lappend filenamelist $file
	lappend filenameorg  $file
      }
      default CantDoThat
    }
  }
  if {$filenamelist != {}} {
    ViewAny $filenamelist $extList $filenameorg
  }
}

proc MoveToTmp { fileelem inst } {
  global glob
  set r [regexp {ftp://([^/]*)(.*)} \
	     $glob($inst,pwd) match ftpI directory]
  if {$r == 0} { 
    PopError [_ "Can't parse %s as ftp URL" $glob($inst,pwd)]
    return {}
  } else { 
    set r 0
    if { ! [file exists $glob(tmpdir)] } {
      set r [Try { file mkdir $glob(tmpdir) } "" 1]
    }
    if { !$r } {
      set size [lindex $fileelem 3]
      if {[lindex $fileelem 2] == "fl"} {set size -1}
      set r [Try { 
	FTP_GetFile $ftpI "$directory/[lindex $fileelem 1]" \
	    "$glob(tmpdir)/[lindex $fileelem 1]"\
	    $size 0 } "" 1]
      if {$r == 0} {
	set glob(havedoneftp) 1 
	#	                  puts "$glob(tmpdir)/[lindex $fileelem 1]"
	return [regsub -all {\ }\
		    "$glob(tmpdir)/[lindex $fileelem 1]" {\\ }]
      }
    }
  }
}


proc CmdViewAsText {} {
  global glob
  CmdViewAsText_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdViewAsText_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
}

proc CmdViewAsText_ { listb_name filelist_var frompwd topwd } {
  global glob
  # For speed, (hopefully) we'll call by reference...
  upvar $filelist_var filelist
  set filenamelist {}
  set inst $glob(select_cur_lr)
  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      wl  { ViewText [TranslateLnk [wLinkName $inst $elem] \
		      [lindex $glob($inst,df) 1]]
      }
      l   -
      n   { ViewText $frompwd/[lindex $elem 1] }
      ld  -
      wld -
      d   { PopInfo [_ "Can't view directory %s in the text viewer" \
			 "$frompwd/[lindex $elem 1]"] }
      fn  -
      fl  { ViewText filenamelist [MoveToTmp $elem $inst]}
      default CantDoThat
    }
  }
}

proc CmdCheckSize {} {
  global glob
  CmdCheckSize_ $glob(listbox,left).file glob(left,filelist)\
      $glob(left,pwd) $glob(right,pwd) left
  CmdCheckSize_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right
}

proc CmdCheckSize_ { listb_name filelist_var frompwd topwd inst } {
  # For speed, (hopefully) we'll call by reference...
  global glob config env
  upvar $filelist_var filelist
  set filenamelist {}
  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "View"]]} return
    set fileelem [lindex $filelist $sel]
    switch [lindex $fileelem 2] {
      d   -
      ld  -
      wld -
      wl  -
      l   -
      n   { lappend filenamelist [Esc $frompwd/[lindex $fileelem 1]] }
      default CantDoThat
    }
  }
  if {$filenamelist != {}} {
    set r [catch {eval eval exec $config(cmd,du) $filenamelist} out]
    if {$r} {
      PopError $out
    } else {
      ViewString [_ "Output from %s" "du"] out ""
    }
  }
}

proc CmdWhatIs {} {
  global glob
  CmdWhatIs_ $glob(listbox,left).file glob(left,filelist)\
      $glob(left,pwd) $glob(right,pwd)
  CmdWhatIs_ $glob(listbox,right).file glob(right,filelist)\
      $glob(right,pwd) $glob(left,pwd)
}

proc CmdWhatIs_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  upvar $filelist_var filelist
  set filenamelist {}
  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      l   -
      wl  -
      wld -
      n   -
      ld  -
      d   { Try { PopInfo [exec file "$frompwd/[lindex $elem 1]"] } "" 1 
          }
      default CantDoThat
    }
  }
}

proc CmdEdit {} {
  global glob
  CmdEdit_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdEdit_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
}

proc CmdEdit_ { listb_name filelist_var frompwd topwd } {
  global env config glob
  # For speed, (hopefully) we'll call by reference...
  upvar $filelist_var filelist
  set filenamelist {}
  set inst $glob(select_cur_lr)

  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    switch -glob $swt {
      wl* {
	set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      default {set ffile $frompwd/[lindex $elem 1]}
    }
    switch  $swt {
      l   -
      wl  -
      n   { lappend filenamelist [FixFileName  $ffile 2 {\[ $}] }
      ld  -
      wld -
      d   { PopInfo [_ "Can't edit directory %s in the text editor" "$ffile"] }
      default CantDoThat
    }
  }
  if {$filenamelist != {}} {
    set ex [format [FixFormatString $config(editor)] $filenamelist]
    set cmd "[ReSpaceString exec $ex] &"
    Try $cmd [_ "Can't start editor"] 1
  }
}

proc CmdQEdit {} {
  global glob
  CmdQEdit_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdQEdit_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
}

proc CmdQEdit_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global glob
  upvar $filelist_var filelist
  set inst $glob(select_cur_lr)

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Q-Edit"]]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    switch -glob $swt {
      wl* {
	set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      default {set ffile $frompwd/[lindex $elem 1]}
    }
    switch $swt {
      wl  -
      l   -
      n   { 
            set r [Try {EditText "$ffile" ""} \
		       [_ "Error editing %s" $ffile] 1]
            if {$r != 0} { catch { destroy .toplevel_$glob(toplevelidx) } }
          }
      ld  -
      d   { PopInfo [_ "Can't edit directory %s in the text editor" "$ffile"] }
      default CantDoThat
    }
  }
}


proc CmdRename {} {
  global glob
  CmdRename_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdRename_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
  set glob(forceupdate) 0
}

proc CmdRename_ { listb_name filelist_var frompwd topwd } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Rename"]]} return
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      d   -
      wl  -
      l   -
      wld -
      ld  -
      n   { 
        if {[CheckWhoOwns $frompwd/[lindex $elem 1] rename]} {
          set newname [EntryDialog "" \
			   [_ "Rename"] \
			   [_ "Please enter new name."] \
			   $frompwd/[lindex $elem 1] question [buildDialogConfig]]
          if {$newname != ""} {
            if {[CheckWhoOwns $newname overwrite]} {
              Log [_ "Renaming %s to %s" $frompwd/[lindex $elem 1] $newname]
              Try { file rename -force -- $frompwd/[lindex $elem 1] $newname }\
		  "" 1
            }
          }
        }
      }
      fl  -
      fld -
      fd  -
      fn  {
        set newname [EntryDialog  "" [_ "Rename"] \
			 [_ "Please enter new name."] \
			 $frompwd/[lindex $elem 1] question [buildDialogConfig]]
        if {$newname != ""} {
          Log [_ "Renaming %s to %s" "$frompwd/[lindex $elem 1]" $newname]
          set r [regexp {ftp://([^/]*)(.*)} $frompwd/[lindex $elem 1]\
		     match ftpI oldftpname]
          if {!$r} {
            PopError [_ "Error in URL %s" $frompwd/[lindex $elem 1]]
          } else {
            set r [regexp {ftp://([^/]*)(.*)} $newname match ftpI newftpname]
            if {!$r} {
              PopError [_ "Error in URL %s" $newname]
            } else {
              Try { FTP_Rename $ftpI $oldftpname $newftpname } "" 1
              set glob(forceupdate) 1
            }
          }
        }
      }
      default CantDoThat
    }
  }
}


proc CmdUnArc {} {
  CmdUnArcPack unarc
}
proc CmdUnPack {} {
  CmdUnArcPack unpack
}

proc CmdUnArcPack {which} {
  global glob
  CmdUnArcPack_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) $which
  CmdUnArcPack_ $glob(listbox,right).file glob(right,filelist)\
      $glob(right,pwd) $glob(left,pwd) $which
  UpdateWindow both
}

proc CmdUnArcPack_ { listb_name filelist_var frompwd topwd which} {
  upvar $filelist_var filelist
  global glob
  set inst $glob(select_cur_lr)
  foreach sel [$listb_name curselection] {
    if {[CheckAbort $which]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    switch -glob $swt {
      wl* {
	set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      default {set ffile $frompwd/[lindex $elem 1]}
    }
    switch $swt {
      ld  -
      wld -
      d   { PopError [_ "Can't %s directory %s..." $which [lindex $elem 1]] }
      l   -
      wl  -
      n   { Log [_ "Which %s to %s" $ffile $topwd]
            UnArcPackAny $ffile $topwd $which
          }
      default CantDoThat
    }
  }
}


proc CmdArc {} {
  global glob
  CmdArc_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdArc_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
  UpdateWindow both
}

proc CmdArc_ { listb_name filelist_var frompwd topwd } {
  global config glob
  upvar $filelist_var filelist
  set inst $glob(select_cur_lr)

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Archive"]]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    switch -glob $swt {
      wl* {
	set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
	set ffile [file join $frompwd $ffile]
      }
      default {set ffile $frompwd/[lindex $elem 1]}
    }
    set tail [file tail $ffile]
    set dir [file dirname $ffile]
    switch $swt {
      wl  -
      l   -
      n   { 
        Log [_ "Packing %s" $ffile]
#        Try { eval exec [format $config(cmd,pack) \
#	    {$ffile}] } "" 1  $glob(async)
        Try { eval eval exec [format $config(cmd,pack) [Esc $ffile]] }\
	    "" 1  $glob(async)
      }
      wld -
      ld  -
      d   { 
        Log [_ "Archiving %s" $ffile]
        if {$config(cmd,archive) == "tar+gz {%s}"} {
          Try { cd $dir; exec tar cf - $tail | \
		    gzip > $tail.tar.gz } "" 1 $glob(async)
        } else {
          Try { cd $dir; eval eval exec \
		    [format $config(cmd,archive) \
			 [Esc $ffile] \
			 $topwd  [Esc $ffile] ] }\
	      "" 1 $glob(async)
        }
      }
      default CantDoThat
    }
  }
}

proc CmdPrint {} {
  global glob
  CmdPrint_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd)
  CmdPrint_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd)
}

proc CmdPrint_ { listb_name filelist_var frompwd topwd } {
  global config glob
  upvar $filelist_var filelist
  set inst $glob(select_cur_lr)

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Print"]]} return
    set elem [lindex $filelist $sel]
    set swt [lindex $elem 2]
    switch -glob $swt {
      wl* {
	set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      default {set ffile $frompwd/[lindex $elem 1]}
    }
    switch $swt {
      wl  -
      l   -
      n   { Log [_ "Printing %s" $ffile]
            Try {eval eval exec [format $config(cmd,print) [Esc $ffile]] } "" 1 }
      ld  -
      wld -
      d   { PopError [_ "Can't print directories!!"] }
      default CantDoThat
    }
  }
}

proc CmdMakeDir {} {
  global config glob
  if { [info exists glob(whichdir)] } {
    set newdir [$glob(win,$glob(whichdir)).entry_dir get]
  } else {
    set newdir [EntryDialog "" [_ "Directory name?"] \
		    [_ "Please enter the name of the new directory.\
                        Another way of creating directories is to enter\
                        the name the new directory in one\
                        of the directory entries and then pressing the\
                        MkDir button"] "$glob(left,pwd)" \
		    question [buildDialogConfig]]
    if {$newdir == ""} return
  }
  Log [_ "Creating directory %s" $newdir]
  set r [regexp {ftp://([^/]*)(.*)} $newdir match ftpI dir]
  if {$r} {
    Try { FTP_MkDir $ftpI "$dir" } "" 1
    set glob(forceupdate) 1
  } else {
    Try { file mkdir $newdir } "" 1
  }
  UpdateWindow both
  set glob(forceupdate) 0
}

proc CmdSelect {} {
  global glob
  if { [info exists glob(whichdir)] } {
    set pat [$glob(win,$glob(whichdir)).entry_dir get]
    set inst $glob(whichdir)
  } else {
    PopInfo [_ "Please enter a selection pattern in one of the\
                directory entries and then press the Select button"]
    return
  }
  $glob(win,$inst).entry_dir delete 0 end
  $glob(win,$inst).entry_dir insert end $glob(${inst},pwd)
  set pat [file tail $pat]
  set i 0
  foreach elem $glob($inst,filelist) {
    if {[string match $pat [lindex $elem 1]]} {
      $glob(listbox,$inst).file selection set $i
    }
    incr i
  }
  propagateSelection $glob(listbox,$inst).file
  UpdateStat
}

proc CmdCSelect {} {
  global glob
  set cmd [EntryDialog  "" [_ "Contents-select"] \
	       [_ "Make sure you have selected the files you want to\
                   search in, then please edit this command to do a\
                   contents-select."] "grep -i " {} [buildDialogConfig]]
  if { $cmd == "" } return
  CmdCSelect_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) $cmd
  CmdCSelect_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) $cmd
  UpdateStat
}

proc CmdCSelect_ { listb_name filelist_var frompwd topwd cmd } {
  upvar $filelist_var filelist

  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      l   -
      wl  -
      n   { 
            set r [catch { eval exec $cmd {$frompwd/[lindex $elem 1]} } outp]
            if { $r != 0 } {
              $listb_name selection clear $sel
            }
          }
      default CantDoThat
    }
  }
}

proc CmdRunCmd {{duo 0} {thisone {}} } {
  frputs "Run command called to run $thisone "
  global glob
  CmdRunCmd_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) $duo $thisone
  CmdRunCmd_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) $duo $thisone
}

proc CmdRunCmd_ { listb_name filelist_var frompwd topwd duo thisone} {
  global glob config
  upvar $filelist_var filelist

  set inst $glob(select_cur_lr)
  set fl {}
  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      wl  {
	lappend fl [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      d   -
      ld  -
      l   -
      n   { lappend fl [lindex $elem 1] }
      default CantDoThat
    }
  }
  if { $fl == "" } return

  if {$duo && $glob(select_pry_lr) != {} } {
    set secdir "$glob($glob(select_pry_lr),pwd)/"
    if { $secdir == "$frompwd/" } {
      set secdir ""
    }
    foreach sel $glob(select_pry_s) {
      lappend fl ${secdir}[lindex $glob($glob(select_pry_lr),filelist) $sel 1]
    }
  }
  set glob($listb_name,run) {}
  if {$thisone != {} && [set indx [lsearch -index {0 0} -exact \
				       $config(runlist) $thisone]] != -1} {
      cmdrunthis $listb_name {} $indx
  } elseif {[llength $config(runlist)] >0 } {
    set glob($listb_name,run) -1
    
    set query [smart_dialog $listb_name.query \
		   [winfo parent $listb_name] \
		   [_ "Programs"] \
		   {} \
		   -1 \
		   1 \
		   [list [_ "Cancel"]]\
		   [list textfun [list cmdrunmenu $listb_name]]]
    if {$glob($listb_name,run) == -1} {return}
  }
  if {$glob($listb_name,run) == {}} {
    set glob($listb_name,full) 1
    set glob($listb_name,add) 0
    set glob($listb_name,display) {}
    set glob($listb_name,file) {}
    set sdr [smart_dialog $listb_name.run \
		 [winfo parent $listb_name] \
		 [_ "Run Dialog"] \
		 [list [_ "Edit the 'command  & ops' line.\
                         \n      Ctrl-A takes you to the start of the line.\
                         \n      Tab does command complete.\
                         \n      Mouse button 3 brings up a browser.\
                         \n      A '%s' in this string will be replaced by the \
                         \n      list of selected file names.  If no '%s' is\
                         \n      present, the file names will follow this string\
                         \n      with a single space separator.\
                         \n'file separator' specifies\
			 what string is used to separate files (should there\
                         \n      be more than one). Default is space ({ }).\
                         \n'display name' if supplied will be the name displayed\
                         in the run list\
                         \n'full file names' will pass the full name rather than\
                         the working directory relative name.\
                         \n" "%s" "%s" ]] \
		 0 \
		 8 \
		 [list [list [_ "command & opts"] \
			    "-textvariable glob($listb_name,run) -width 80"] \
		      [list [_ "file separator"] \
			   "-textvariable glob($listb_name,file)"]\
		      [list [_ "display name"] \
			   "-textvariable glob($listb_name,display)"] \
		      [list [_ "Async"] "-variable glob(async)"]\
		      [list [_ "full file names"] \
			   "-variable glob($listb_name,full)"]\
		      [list [_ "Add to run list"] \
			   "-variable glob($listb_name,add)"]\
		      [list [_ "OK"]] \
		      [list [_ "Cancel"]]\
		     ]\
		 [list -height 16 scroll 15 \
		      bind [list $listb_name.run.0 <Tab> \
				"Complete $listb_name.run.0\
                               $listb_name.run.text ; break"]\
		      bind [list $listb_name.run.0 <3> \
				"CompleteWithBrowse $listb_name.run.0"]\
		     ]]
    if {$sdr == 7 || $sdr == -1 || $glob($listb_name,run) == "" } {return}

    if {![string match {*%s*} $glob($listb_name,run)] } {
      set glob($listb_name,run) "$glob($listb_name,run) %s"
    }
    if {$glob($listb_name,file) == {}} {
      set glob($listb_name,file) " "
    }
    if {$glob($listb_name,add)} {
      if {$glob($listb_name,display) == {}} {
	set glob($listb_name,display) [lindex $glob($listb_name,run) 0]
      }
      set new [list [list $glob($listb_name,display) $glob($listb_name,run)] \
		   $glob($listb_name,file)]
      if {$glob($listb_name,full)} {lappend new "fullname"}
      if {$glob(async)}            {lappend new "async"}
      lappend config(runlist) $new
    }
  }
  set cmd [FixFormatString $glob($listb_name,run)]
#  puts "run $cmd sdr = $sdr"
  if {$glob($listb_name,full)} {
    set fll $fl
    set fl {}
    foreach file $fll {
      if {[string range $file 0 0] != "/"} {
	set file "$frompwd/$file"
      }
      lappend fl [FixFileName $file 2 {\{ $}]
    }
  }
  set fl [join $fl $glob($listb_name,file)]
  set cmd [format  $cmd $fl]
  LogSilent [_ "Running command:\n%s" [ReSpaceString "exec" $cmd]]
  cd $frompwd
  if {$glob(async)} {
    catch "[ReSpaceString {exec} $cmd] &"  out
    return
  } else {
    catch "[ReSpaceString {exec} $cmd]"  out
  }
  if { $out != "" } {
    ViewString [_ "Output from command"] out ""
  }
  UpdateWindow both
}

proc cmdrunmenu {listb_name w} {
  global glob config
  set idx 0
  set sel_bg [lindex [$w config -selectbackground] 4]
  set bg     [lindex [$w config -background] 4]
  set fg     [lindex [$w config -foreground] 4]
  set sel_fg [lindex [$w config -selectforeground] 4]

  foreach pgm [concat $config(runlist)\
		   [list {} [list [list [_ "Enter program name" ]]]]] {
    if {[lindex $pgm 0 0] == {} } {
      $w insert insert [_ "Select from above -----OR---\n"]
    } else {
      $w insert insert "[lindex $pgm 0 0]\n" tag$idx
      $w tag bind tag$idx <1> "cmdrunthis $listb_name $w $idx"
      $w tag bind tag$idx <Enter> "$w tag config tag$idx \
                                 -background $sel_bg -foreground $sel_fg"
      $w tag bind tag$idx <Leave> "$w tag config tag$idx \
                                 -background $bg -foreground $fg"
    }
    incr idx
  }
  $w delete end-1c
}

proc cmdrunthis { listb_name w indx } {
  global glob config
  if {$w != {} } {
    destroy [winfo parent $w]
  }
  if {[set glob($listb_name,run) [lindex $config(runlist) $indx 0 1]] == {} } {
    return
  }
  set glob($listb_name,file) [lindex $config(runlist) $indx 1]
  set glob($listb_name,full) 0
  set glob(async)            0
  foreach val [lrange [lindex $config(runlist) $indx] 2 end] {
    switch -glob $val {
      async {set glob(async) 1}
      full* {set glob($listb_name,full) 1}
    }
  }
  return
}

proc CmdForEach {} {
  global glob
  CmdForEach_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) 
  CmdForEach_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) 
}

proc CmdForEach_ { listb_name filelist_var frompwd topwd } {
  global glob config
  upvar $filelist_var filelist
  set inst $glob(select_cur_lr)

  set fl {}
  foreach sel [$listb_name curselection] {
    set elem [lindex $filelist $sel]
    switch [lindex $elem 2] {
      wl {
	lappend fl [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
      }
      d   -
      ld  -
      l   -
      n   { lappend fl [lindex $elem 1] }
      default CantDoThat
    }
  }
  if { $fl == "" } return
  if {$glob(async)} {
    PopError [_ "This command does not support asynchronous execution"]
    return
  }
  if {![info exists glob(foreach,cmd)] || $glob(foreach,cmd) == {}} {
    set glob(foreach,cmd) {"echo '%s'"}
  }
  set glob(foreach,cmd) \
      [EntryDialog "" [_ "Foreach"] \
	   [_ "Enter command to run on each of the selected files.\
               The file will show up in the '%s'. You can use pipes\
               and other bourne-shell syntax elements since the\
               commands will each run in a separate bourne shell." "%s"]\
	   $glob(foreach,cmd) {}  [buildDialogConfig]]
  if { $glob(foreach,cmd) == "" } return

  set output {}
  foreach k $fl {
    if {[CheckAbort [_ "ForEach"]]} return
    set cmd [format [FixFormatString "$glob(foreach,cmd)"] \
		 [FixFileName $k 2 {\[ $}]]
    #append output "\$ $cmd\n"
    Log [_ "Running %s ..." [ReSpaceString "exec $config(cmd,sh)"  $cmd]]
    catch { 
      cd $frompwd 
      uplevel 0 [ReSpaceString "exec $config(cmd,sh)"  $cmd] 
    } out
    append output "$out\n"
  }
  ViewString [_ "Output from commands"] output ""
  UpdateWindow both
}

proc CmdRecurseCommand { inst } {
  global glob config

  set dir $glob($inst,pwd)

  if { [IsFTP $dir] } {
    CantDoThat
    return
  }

  if {$glob(async)} {
    PopError [_ "This command does not support asynchronous execution"]
    return
  }
  if {![info exists glob(foreach,cmd)] || $glob(foreach,cmd) == {}} {
    set glob(foreach,cmd) {echo '%s'}
  }
  set e [EntryDialogDouble [_ "Run Command Recursively"] \
	     [_ "Enter command to run on each file.\
                 The file will show up in the '%s'.\
                 You can use pipes and other bourne-shell syntax\
                 elements since the commands will each run in a\
                 separate bourne shell." "%s" ]\
	     [_ "Enter pattern to match for when recursing into directories."]\
	     [_ "This command will run a '%s' of the type\n\n    %s\n\nto\
                 recurse into the current directory (%s).\
                 The command will then be run on all files\
                 from this find.\n\nSee also: manpage for \
                 the find command.\n\nUse tab to go to next entry.\
                 Return or the OK button starts execution."\
                 "find" "$ find <directory> -type f -name <pattern> -print"\
                 $dir] $glob(foreach,cmd) {*}]
  if { $e == "" } return

  set glob(foreach,cmd) [lindex $e 0]
  set pattern [lindex $e 1]
  set output {}

  # expand file list with find outputs
  set r [catch {cd $dir ; uplevel 0 \
		    exec $config(cmd,find) . -type f -name $pattern -print} out]
  if {$r} {
    PopError "$out"
    return
  }
  set fl [split $out \n]
  foreach k $fl {
    if {[CheckAbort [_ "Recurse Command"]]} return
    set cmd [format "$glob(foreach,cmd)" $k]
    append output "\$ $cmd\n"
    LogStatusOnly [_ "Running %s ..." $cmd]
    catch { cd $dir ; uplevel 0 exec $config(cmd,sh)  \"$cmd\" } out
    append output "$out\n"
  }
  ViewString [_ "Output from commands"] output ""
  UpdateWindow both
}


proc CmdDiff {} {
  global glob
  CmdDiff_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) left

  CmdDiff_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right
}

proc CmdDiff_ { listb_name filelist_var frompwd topwd inst } {
    global glob
    upvar $filelist_var filelist
    global config

    set null 1
    set file1 ""
    set file2 ""
    cd $frompwd
    foreach sel [$listb_name curselection] {
      set null 0
      set elem [lindex $filelist $sel]
      set swt [lindex $elem 2]
      switch -glob $swt {
	wl* {
	  set ffile [TranslateLnk [wLinkName $inst $elem] \
		       [lindex $glob($inst,df) 1]]
	}
	default {set ffile $frompwd/[lindex $elem 1]}
      }
      switch $swt {
	ld  -
	d   -
	l   -
	n   { 
	  if {$file1 == ""} { 
	    set file1 $ffile 
	  } else {
	    if { $file2 != "" } { 
	      PopError [_ "Please select one or two\
                                    files or directories for diffing."]
	      return
	    }
	    set file2 $ffile 
	    # But which was first?
	    if {$inst == $glob(select_pry_lr) && 
		$sel == $glob(select_pry_s)} { } else {
		  set tmp $file1
		  set file1 $file2
		  set file2 $tmp
		    }
		}
	    }
	    default CantDoThat
	}
    }

    if {$null} return

  if {$file2 == "" && $glob(select_pry_lr) != {}} {
	set sel $glob(select_pry_s)
	if {[llength $sel] == 1} {
	    set elem2 [lindex $glob($glob(select_pry_lr),filelist) $sel]
	    set file2  $glob($glob(select_pry_lr),pwd)/[lindex $elem2 1]
	  switch -glob [lindex $elem 2] {
	    wl* {
	      set file2 [TranslateLnk [wLinkName $glob(select_pry_lr) $elem] \
		       [lindex $glob($inst,df) 1]]
	    }
	  }
	} else {
	  PopError [_ "Please select one or two\
                         files or directories for diffing."]
	  return
	}
    }     
  if {! ($file2 == "")} {
    set tmp $file1
    set file1 $file2
    set file2 $tmp
  }
  set ex [format [FixFormatString $config(cmd,diff)] \
	      [FixFileName $file1 2 {\[ $}] [FixFileName $file2 2 {\[ $}]]
#  set cmd [ReSpaceString exec $ex]
   LogStatusOnly [ReSpaceString exec $ex] 
  set r [catch  [ReSpaceString exec $ex]  outp]	
#     set r [catch { eval eval \
#		      exec [format $config(cmd,diff) [Esc $file1] [Esc $file2]] \
#		     } outp]
  if { $r != 0 || [string length $outp] > 3} {
    ViewString [_ "Diffing %s and %s" $file1 $file2] outp "diff.log"
  } else {
    PopInfo [_ "No difference between\n\n%s\n\nand\n\n%s" $file1 $file2]
  }
}

proc CmdCreateEmptyFile { inst } {
  global glob config
  set start_entry $glob($inst,pwd)
  set newfile [EntryDialog  "" [_ "Create New File"] \
		   [_ "Please enter the name of the new file."] \
		   $start_entry question [buildDialogConfig]]

  if {$newfile != ""} {
    Log [_ "Creating new file %s" $newfile]
    Try { exec $config(cmd,touch) "$newfile" } "" 1
    UpdateWindow both
  }
}

proc DeleteFTPRecursive { dir inst } {
  global glob config
  set r [regexp {ftp://([^/]*)(.*)} $dir match ftpI directory]
  Log [_ "FTP recursive delete: Entering %s" $dir]
  NewPwd $inst $dir
  UpdateWindow $inst
  foreach elem $glob($inst,filelist) {
    switch [lindex $elem 2] {
      fn  -
      fld -
      fl  {
        Log [_ "Deleting %s" $dir/[lindex $elem 1]]
        FTP_Delete $ftpI "$directory/[lindex $elem 1]"
      }
	fd { 
	    
	  if { [lindex $elem 1] != "." } {
	      if { [lindex $elem 1] != ".." } {
		  DeleteFTPRecursive "$dir/[lindex $elem 1]" $inst
	      }
	  }
      }
      default {
        error [_ "Unexpected file type in FTP recursive delete"]
      }
    }
  }
  Log [_ "Deleting %s" $dir]
  NewPwd $inst "$dir/.."
  UpdateWindow $inst
  FTP_RmDir $ftpI "$directory"
}

proc CopyFromFTPRecursive { fromdir todir inst resume } {
  global glob config
  if {[CheckAbort [_ "CopyFromFTPRecursive"]]} return
  set r [regexp {ftp://([^/]*)(.*)} $fromdir match ftpI directory]
  set dir [file tail $directory]
  Log [_ "FTP recursive copy: Creating %s" $todir/$dir]
  file mkdir "$todir/$dir"
  Log [_ "FTP recursive copy: Entering %s" $fromdir]
  NewPwd $inst $fromdir
  UpdateWindow $inst
  foreach elem $glob($inst,filelist) {
    if {[CheckAbort [_ "CopyFromFTPRecursive"]]} return
    switch [lindex $elem 2] {
      fld -
      fl {
        Log [_ "Skipping %s - link" $fromdir/[lindex $elem 1]]
      }
      fd {
	  if { [lindex $elem 1] != "." } {
	      if { [lindex $elem 1] != ".." } {
		  CopyFromFTPRecursive "$fromdir/[lindex $elem 1]" \
		      "$todir/$dir" $inst $resume
	      }
	  }
      }
      fn {
        Log [_ "FTP recursive copy: Copying %s -> %s bytes)" \
             $fromdir/[lindex $elem 1] \
             "$todir/$dir/[lindex $elem 1] ([lindex $elem 3]"]
        FTP_GetFile $ftpI "$directory/[lindex $elem 1]" \
	    "$todir/$dir/[lindex $elem 1]" "[lindex $elem 3]" $resume
      }
      default {
        error [_ "Unexpected file type in FTP recursive copy"]
      }
    }
  }
}

proc CopyToFTPRecursive { fromdir todir inst } {
  global glob config
  if {[CheckAbort [_ "CopyToFTPRecursive"]]} return
  set r [regexp {ftp://([^/]*)(.*)} $todir match ftpI directory]
  set dir [file tail $fromdir]
  Log [_ "FTP recursive copy: Creating %s" $todir/$dir]
  FTP_MkDir $ftpI "$directory/$dir"
  Log [_ "FTP recursive copy: Entering %s" $fromdir]
  NewPwd $inst $fromdir
  UpdateWindow $inst
  foreach elem $glob($inst,filelist) {
    if {[CheckAbort [_ "CopyToFTPRecursive"]]} return
    switch [lindex $elem 2] {
      ld -
      l {
        Log [_ "Skipping %s - link" $fromdir/[lindex $elem 1]]
      }
      d {
 	  if { [lindex $elem 1] != "." } {
	      if { [lindex $elem 1] != ".." } {
		  CopyToFTPRecursive "$fromdir/[lindex $elem 1]" \
		      "$todir/$dir" $inst
	      }
	  }
      }
      n {
        Log [_ "FTP recursive copy: Copying %s -> %s bytes)"\
		 $fromdir/[lindex $elem 1] \
		 "$todir/$dir/[lindex $elem 1] ([lindex $elem 3]"]
        FTP_PutFile $ftpI "$fromdir/[lindex $elem 1]" \
	    "$directory/$dir/[lindex $elem 1]" "[lindex $elem 3]"
      }
      default {
        error [_ "Unexpected file type in FTP recursive copy"]
      }
    }
  }
}

proc CmdFind { inst } {
  global glob config
  set findname [EntryDialog  "" [_ "Find..."] \
		    [_ "Please enter substring of filename\
                        to search for in %s and below." $glob($inst,pwd)] \
		    "" "question" {} [buildDialogConfig]]
  if {$findname == ""} return
  if {[IsFTP $glob($inst,pwd)]} {
 #   regexp {ftp://([^/]*)(.*)} $glob($inst,pwd) match ftpI directory
    set r [catch {FTP_CD $ftpI $directory} out]
    if {$r != 0} {
      PopError $out
      return
    }
    LogStatusOnly [_ "Searching, please wait..."]
    set r [catch {FTP_DoSearch $ftpI $findname} out]
    LogStatusOnly [_ "Searching, please wait...done"]
    if {$r} {
      PopError [_ "FTP search error: %s" $out]
      return
    }
    ViewString [_ "FTP search results"] out ""
    return
  }
  set r [catch {cd $glob($inst,pwd)} out]
  if {$r} {
    PopError "$out"
    return
  }
  set pat "\\\"*$findname*\\\""
  LogStatusOnly [_ "Searching, please wait..."]
  set r [catch {eval  \
		    exec $config(cmd,sh)  \
		    \"find . -name $pat -print 2> /dev/null\"} out]
  eval {puts "exec $config(cmd,sh)  \
		    find . -name $pat -print 2> /dev/null"}
  LogStatusOnly [_ "Searching, please wait...done"]
#  if {$r} {
#    PopError "Search error: $out"
#    return
#  }
  set out [split $out "\n"]
  if {[string range [lindex $out end] 0 4] == "child"} {
    set out [lrange $out 0 [expr [llength $out] - 2]]
  }
  if {[string trim $out] == ""} {
    PopInfo [_ "No file found"]
    return
  }
  FindDialog $out $inst
}


proc CmdChmod {} {
  global glob
  CmdChmod_ $glob(listbox,left).file glob(left,filelist) \
      $glob(left,pwd) $glob(right,pwd) left
  CmdChmod_ $glob(listbox,right).file glob(right,filelist) \
      $glob(right,pwd) $glob(left,pwd) right
}

proc CmdChmod_ { listb_name filelist_var frompwd topwd inst } {
  # For speed, (hopefully) we'll call by reference...
  global config glob
  upvar $filelist_var filelist
  set fl {}
  

  foreach sel [$listb_name curselection] {
    if {[CheckAbort [_ "Chmod"]]} return
    set elem [lindex $filelist $sel]
    lassign $elem {*}$glob(fListEl)
    switch [lindex $elem 2] {
      l   -
      ld  -
      n   -
      d   {
	incr ftpFlag 0
	if {$fl == {}} {
	  set localMode [file attributes \
			     $frompwd/$file \
			     -permissions]
	  lassign [split $usergroup /] user group
	}
      }
      default {
	# Must be an nFTP, maybe we can do it... up to the handler and remote
	incr ftpFlag
	if {$fl == {}} {
	  set localMode [GetModeFromString $mode]
	  lassign [split $usergroup /] user group
#	  puts "got $mode from >[lindex $elem 5]<"
	}
      }
    }
    lappend fl  $frompwd/$file
  }
  if {$fl != ""} {
    #set fi [FixFileName  $fl 1 {\[ $}]
    set fi $fl
    set rarg [ChmodDialog "$frompwd/$file" $localMode $user $group]
    lassign $rarg arg ownarg
    if {$arg != ""} {
      if { $ftpFlag } {
	# for ftp we will use a seperate call for each file...
	foreach file $fl {
	  set r [regexp {ftp://([^/]*)(.*)} $file match ftpI fl]
	  if {$r == 0} { 
	    PopError [_ "Can't parse %s as ftp URL" $frompwd] 
	  } else {
	    set r [FTP_Chmod $ftpI $arg $fl]
	    if { $r != "0" && $r != "" } {
	      PopError $r
	      break
	    }
	  }
	}
      } else {
	Try "exec $config(cmd,chmod) $arg $fi" "" 1 $glob(async)
      }
      ForceUpdate $inst
    }
    if {$ownarg != ""} {
      if { $ftpFlag } {
	# for ftp we will use a seperate call for each file...
	foreach file $fl {
	  set r [regexp {ftp://([^/]*)(.*)} $file match ftpI fl]
	  if {$r == 0} { 
	    PopError [_ "Can't parse %s as ftp URL" $frompwd] 
	  } else {
	    set r [FTP_Chown $ftpI $ownarg $fl]
	    if { $r != "0" && $r != "" } {
	      PopError $r
	      break
	    }
	  }
	}
      } else {
	Try "exec $config(cmd,chown) $ownarg $fi" "" 1 $glob(async)
      }
      ForceUpdate $inst
    }
    
  }
}

proc CmdGetHttp { inst } {
  global glob config
  
  if {[IsFTP $glob($inst,pwd)]} {
    PopInfo [_ "You can only download HTTP files to a non-FTP directory"]
    return
  }

  if {![info exists glob(http,lasturl)]} {
    set glob(http,lasturl) {}
  }
  set URL $glob(http,lasturl)

  while { 1 } {
    set URL [EntryDialog  "" [_ "Get HTTP File"] \
		 [_ "Please enter HTTP URL to download"] $URL\
		 {} [buildDialogConfig]]
    if {$URL == ""} {
      return
    }
    
    if {[string range $URL 0 6] != "http://" } {
      set URL "http://$URL"
    }
    
    set r [regexp {http://([^/]*)(.*)} $URL match host_and_port location]
    if {!$r} {
      PopError [_ "Could not parse %s as an HTTP URL" $URL]
      continue
    } 
    if {$location == ""} {
      append URL /
    }
    set glob(http,lasturl) $URL
    break
  }

  set filename [file tail $URL]
  if {[string range $URL end end] == "/"} {
    append filename .html
  }
  set filename [EntryDialog  "" [_ "Get HTTP File"] \
		    [_ "Please edit filename to save to.\n(URL: %s)" $URL] \
		    $filename {} [buildDialogConfig]]
  if {$filename == ""} {
    return
  }
  cd $glob($inst,pwd)
  HTTP_Get $URL $filename
  UpdateWindow both
}

