#
# This function is to set up a enhanced 'puts' routine (see below)
# which can be globally turned off...
#
#  setupDebug   defines either a dummy or the real function
#
#  parameter  on  1 turns on the debug routine
#                 0 (or {}) makes the debug routine a dummy
#


proc setupDebug {{on 0} } {
  if {$on} {

    # A smart puts routine.  Each argument is tested for a trailing blank
    # if there is one, it is stripped and the result is put in the final string
    # if not, the argument is assumed to be a var name.  If it exists:
    # <name>=$<name> is put int he final string, if not <unset> is used as 
    #  the value finally, the final string is processed to change all
    #  \r \t and \n chars to the backslash equivalents.

    proc frputs { args } {
      set m {}
      foreach ar  $args {
	if {[string range $ar end end] == " " } {
	  set m [set m][string range $ar 0 end-1]
	} elseif { ! [catch "uplevel \"info exists $ar\" " ro] &&  $ro } {
	  set m "[set m]$ar=[uplevel "set $ar"]< "
	} else {
	  set m "[set m]$ar=<unset> "
	}
      }
      regsub -all {\n} $m {\\n} m
      regsub -all {\r} $m {\\r} m
      regsub -all {\t} $m {\\t} m
      puts "[set m]"
      flush stdout
    }
  } else {
    proc frputs {args} {}
  }
}
# So you don't need to call setupDebug...
proc frputs {args} {}
